/* Game.h
Defines the Game class
(C) 2000 N. Douglas
18th April 2000
*/

#include "common.h"
#include "Preferences.h"
#include "WaterEngine.h"
#include "Tool.h"
#include "windows.h"

class Game
{
public:
	HWND hwndMain;
	WaterEngine *we;
	Bitmap *bmp;
	bool automolno;
	DWORD mythreadID;
	Preferences prefs;

private:
	HINSTANCE hinst;				// handle of parent process
	char name[1024];
	DWORD timeofcreation;

	HMENU hwndMainMenu;
	HMENU hwndMainMenuPopup;
	HMENU hwndMainMenuQLoad;
	HACCEL hacclMain;
	HANDLE mythreadH;				// handle of our thread
	DWORD parentthreadID;
	int nCmdShow;
	Tool *tool;
	HWND hwndMolNo;
	HWND hwndMolCol;
	HWND hwndCalibr;

	int bmpscale;
	int oldbmpX, oldbmpY;
	bool lockX, lockY;
	bool drawing, paused;
	int fps[5], fpsidx;
	int fpsAtMols[1000];
private:
	// Toolbox stuff
	HWND hwndToolbox;
	int alignside, toolboxdy;
	ToolLine linetool;
	ToolCap captool;
	ToolPumpUp pumpUptool;
	ToolPumpLeft pumpLefttool;
	ToolPumpRight pumpRighttool;
	ToolAFilter filtAtool;
	ToolRFilter filtRtool;
	ToolBFilter filtBtool;

private:
	void Game::final();

public:
	Game::Game(HINSTANCE hInstance, DWORD parentthreadid, char *_name, int _nCmdShow);

	Game::~Game();

	s32 Game::threadexe();

	LRESULT Game::wndproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	// Called by dialog callback handlers
	void Game::alignToolbox(LPWINDOWPOS wp, bool update);
	void Game::updateToolbox();

private:
	void Game::updateMenus();

	void Game::SetMainWindowSize();

};
