/* Preferences.cpp
Implements the Preferences handling module
(C) 2000 N. Douglas
13th August 2000
*/

#include "common.h"
#include "Preferences.h"

#ifdef SHAREWARE
	const char *keygroup="Software\\ned Productions\\FlowDemo";
#else
	const char *keygroup="Software\\ned Productions\\Flow";
#endif

static HKEY _recCreateKey(HKEY origin, const char *keyname)
{
	HKEY h;
	LONG ret;
	DWORD disp;
	do
	{
		ret=RegCreateKeyEx(origin, keyname, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &h, &disp);
		if(ret!=ERROR_SUCCESS)
		{
			char temp[256];
			HKEY h2;
			strcpy(temp, keyname);
			*strrchr(temp,'\\')=0;
			h2=_recCreateKey(origin, temp);
			TEST_WIN32ERR(ERROR_SUCCESS!=RegCloseKey(h2));
			continue;
		}
	} while(0);
	if(disp==REG_OPENED_EXISTING_KEY) return h;
	if(disp==REG_CREATED_NEW_KEY) return h;
	return NULL;
}

Preferences::Preferences()
{
	DWORD type;
	DWORD len=sizeof(u32);
	TEST_WIN32ERR(!(hkey=_recCreateKey(HKEY_CURRENT_USER, keygroup)));
	if(ERROR_SUCCESS!=RegQueryValueEx(hkey, "NormalMolCol", NULL, &type, (BYTE *) &normalmolcol, &len))
		normalmolcol=0;
	if(ERROR_SUCCESS!=RegQueryValueEx(hkey, "LightMolCol", NULL, &type, (BYTE *) &lightmolcol, &len))
		lightmolcol=0;

}

Preferences::~Preferences()
{
	if(hkey!=NULL)
	{
		TEST_WIN32ERR(ERROR_SUCCESS!=RegCloseKey(hkey));
		hkey=NULL;
	}
}

void Preferences::write()
{
	TEST_WIN32ERR(ERROR_SUCCESS!=RegSetValueEx(hkey, "NormalMolCol", 0, REG_DWORD, (BYTE *) &normalmolcol, sizeof(DWORD)));
	TEST_WIN32ERR(ERROR_SUCCESS!=RegSetValueEx(hkey, "LightMolCol", 0, REG_DWORD, (BYTE *) &lightmolcol, sizeof(DWORD)));
}
