/* common.h
Defines useful constants
(C) 2000 N. Douglas
12th April 2000
*/

#ifndef __common_h_
#define __common_h_
#include <string.h>

// Define this to build a castrated shareware version
//#define SHAREWARE

extern const char licencee[];

#define PROGVERSION "v1.11"
#define PROGDATE	__TIMESTAMP__

#ifdef WIN32
#define STRICT
#include "windows.h"

#define u8 unsigned char
#define s8 signed char
#define u16 unsigned short
#define s16 signed short
#define u32 unsigned long
#define s32 signed long
#else
#error Do not recognise this system
#endif

class Error
{
public:
	char *module;
	u32 lineno;
	bool external;
#ifdef WIN32
	DWORD win32code;
#endif
	char msg[256];

public:
	Error::Error(char *file, int line, const char *message);
	void Error::toString(char *buff, int len);
	void Error::showAsMsg();
};
#define DECLARE_ERROR(e2, m2) Error e2(__FILE__, __LINE__, (const char *) m2);
#define TEST_NOMEM(exp) if((exp)==0) { ; Error e(__FILE__, __LINE__, "Out of memory"); throw e; }
#define TEST_WIN32ERR(exp) if((exp)) { ; Error e(__FILE__, __LINE__, NULL); throw e; }
#define TEST_WIN32MSG(exp) if((exp)) { ; Error e(__FILE__, __LINE__, NULL); e.showAsMsg(); }

// Internal window messages
#define WM_NEWGAMEREQ	WM_USER+8
#define WM_CLOSEGAMEREQ	(WM_NEWGAMEREQ + 1)

// Globals defined in winmain.cpp
extern HINSTANCE hinst;
extern bool debug;

#endif